import java.io.IOException;
import java.util.Date;
import java.util.Random;

import org.asteriskjava.live.AsteriskChannel;
import org.asteriskjava.live.AsteriskServer;
import org.asteriskjava.live.DefaultAsteriskServer;
import org.asteriskjava.live.LiveException;
import org.asteriskjava.live.ManagerCommunicationException;
import org.asteriskjava.live.OriginateCallback;

public class AMIConnection extends Thread implements OriginateCallback{
	private final AsteriskServer asteriskServer;
	private final static Random r=new Random();
	private AMIConnection() throws ManagerCommunicationException{
		
		asteriskServer=new DefaultAsteriskServer(
				"localhost",
				"edu",
				"edu");
		System.out.println("Connected to "+asteriskServer.getVersion());
	}
	
	
	public static void main(String[] args) throws ManagerCommunicationException, IllegalStateException, IOException{
		new AMIConnection().start();
	}
	

	@Override
	public void run() {
		while(true){
			try {
				for(int i=media(12);i>=0;i--){ //6 originates mean
					System.out.println("Generating...");
					asteriskServer.originateToExtensionAsync(
							"SIP/9000", //This is the other Asterisk test
							"prueba", 
							"s", 
							1, 
							media(10*1000), //Timeut 5 seconds mean
							null, 
							null, 
							this);
				}
				synchronized(this){
					System.out.println("Waiting...");
					wait(media(10*1000)); //Do originates 5 seconds mean
				}
			} catch (Exception e) {
				System.err.println(new Date());
				throw new RuntimeException(e);
			}
		}
	}
	
	static int media(int n){
		return r.nextInt(n*2);
	}


	public void onBusy(AsteriskChannel arg0) {
		System.out.println("BUSY");
		
	}


	public void onDialing(AsteriskChannel arg0) {
		System.out.println("PROGRESS");
		
	}


	public void onFailure(LiveException arg0) {
		System.out.println("FAILURE");
		
	}


	public void onNoAnswer(AsteriskChannel arg0) {
		System.out.println("NO ANSWER "+arg0.getState());
		
	}


	public void onSuccess(AsteriskChannel arg0) {
		System.out.println("OK");
		
	}
}
